<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { useRouter } from 'vue-router'; // Importar Vue Router para la navegación

const grafanaUrl = window.GRAFANA_URI;

export default defineComponent({
  name: 'GrafanaDashboard',
  setup() {
    const isLoading = ref(true);
    const panels = ref([]); // Todos los paneles cargados desde localStorage
    const filteredPanels = ref([]); // Paneles que cumplen con la condición
    const hasData = ref(false); // Estado para verificar si hay datos
    const router = useRouter(); // Instancia del router

    const globalParams = {
      orgId: 1,
      refresh: '30s', // Puedes cambiar el refresh según tus necesidades
      kiosk: true, // Cambiar a true
      theme: 'light',
    };

    const generateDashboardUrl = (baseUrl: string, panelId: number) => {
      const params = new URLSearchParams({
        orgId: globalParams.orgId.toString(),
        refresh: globalParams.refresh,
        kiosk: globalParams.kiosk.toString(),
        theme: globalParams.theme,
      });

      // Asegúrate de que baseUrl sea una ruta relativa
      const fullUrl = `${grafanaUrl}${baseUrl}?${params.toString()}&viewPanel=${panelId}`; // Añadimos viewPanel al final
      return fullUrl;
    };

    // Función para cargar el JSON desde localStorage
    const loadPanelsFromLocalStorage = () => {
      const storedData = localStorage.getItem('dashboards');
      if (storedData) {
        panels.value = JSON.parse(storedData); // Asigna los datos a la variable
        hasData.value = true; // Indica que hay datos en localStorage
        isLoading.value = false; // Cambia el estado de carga
        console.log('Datos cargados desde localStorage:', panels.value);

        // Filtrar los paneles con dashboard_view: true
        filteredPanels.value = panels.value.map(panel => ({
          ...panel,
          panels: panel.panels.filter(p => p.dashboard_view)
        })).filter(panel => panel.panels.length > 0); // Solo mantener paneles que tienen dashboard_view: true
        
        // Mostrar en consola los paneles que se deben ver
        const panelsToShow = filteredPanels.value.map(panel => ({
          id: panel.id,
          title: panel.title,
          panels: panel.panels.map(p => p.id), // IDs de los panels que se deben mostrar
        }));
        console.log('Paneles que se deben mostrar:', panelsToShow);
      } else {
        hasData.value = false; // No hay datos en localStorage
        isLoading.value = false; // Termina la carga pero sin datos
      }
    };

    // Redirigir a la página de carga de JSON
    const goToLoadJson = () => {
      router.push('/load_json');
    };

    onMounted(() => {
      loadPanelsFromLocalStorage(); // Cargar los paneles desde localStorage al montar el componente
    });

    return {
      filteredPanels,
      generateDashboardUrl,
      isLoading,
      hasData,
      goToLoadJson,
    };
  },
});
</script>

<template>
  <v-container>
    <!-- Mostrar spinner de carga -->
    <div v-if="isLoading" class="border-spinners">
      <v-progress-circular
        indeterminate
        color="primary"
        size="64"
        class="spinner"
      ></v-progress-circular>
    </div>

    <!-- Mostrar mensaje si no hay datos en localStorage -->
    <div v-else-if="!hasData" class="no-data-container">
      <p>No hay datos cargados. Por favor, carga el JSON.</p>
      <v-btn @click="goToLoadJson" color="primary">
        Cargar JSON
      </v-btn>
    </div>

    <!-- Mostrar los paneles filtrados -->
    <div v-else>
      <v-col
        v-for="panel in filteredPanels" 
        :key="panel.id"
        cols="12"
        class="d-flex"
      >
        <v-card elevation="2" style="padding: 0; margin-bottom: 16px;">
          <v-card-item>
            <iframe
              v-for="p in panel.panels"
              :key="p.id"
              :src="generateDashboardUrl(panel.url, p.id)"
              width="100%"
              height="300px"
              frameborder="0"
              sandbox="allow-forms allow-scripts allow-same-origin"
              @load="console.log('Iframe URL:', generateDashboardUrl(panel.url, p.id))"
            ></iframe>
          </v-card-item>
        </v-card>
      </v-col>
    </div>
  </v-container>
</template>

<style scoped>
.loading-container {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh;
}

.spinner {
  width: 64px;
  height: 64px;
}

.no-data-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  margin-top: 50px;
}

.v-card {
  width: 100%;
}
</style>
